#ifndef Ragdoll_h
#define Ragdoll_h
//////////////////////////////////////////////////////////////////////////////////
// Rag-Doll Template															//
//////////////////////////////////////////////////////////////////////////////////
//
//
// Make sure to define a path that contains ragdoll parts in your own code..
//
// RagDoll working variables
VECTOR*	RD_Hinge1 = { x=0; y=0; z=0; }
VECTOR*	RD_Hinge2 = { x=0; y=0; z=0; }
var 	RD_GroupID = 2;
//
//
//////////////////////////////////////////////////////////////////////////////////
//	FUNCTIONS																	//
//////////////////////////////////////////////////////////////////////////////////
//
// update bone to hinge
void RD_updateBoneHinge(ENTITY* hingeEnt, STRING* bodyPart, ENTITY* actor) 
{
	VECTOR temp_pos, temp_ang, temp_mov, temp_ang_1;
	ENTITY *hingePointer = hingeEnt, *actorPointer = actor;
	STRING* updatePart = bodyPart;

	// reset bone position
	ent_bonereset(actorPointer, updatePart);
	// get bone angle
	vec_for_bone(temp_pos, actorPointer, updatePart);
	ang_for_bone(temp_ang, actorPointer, updatePart);
	// set the entity to the right bone position
	vec_set(temp_mov, hingePointer.x);
	vec_sub(temp_mov, temp_pos);
	// calculate rotation (also based on scale)
	temp_mov.x /= actorPointer.scale_x; temp_mov.y /= actorPointer.scale_y; temp_mov.z /= actorPointer.scale_z;
	vec_rotateback (temp_mov, temp_ang);///change this please
	temp_ang.x = 360-temp_ang.x; temp_ang.y = 360-temp_ang.y; temp_ang.z = 360-temp_ang.z;
	// calculate right bone angle rotation
	vec_set(temp_ang_1, nullvector);
	ang_add(temp_ang_1, vector(temp_ang.x,0,0));
	ang_add(temp_ang_1, vector(0,temp_ang.y,0));
	ang_add(temp_ang_1, vector(0,0,temp_ang.z));
	// set bone rotation angle
	ang_rotate(temp_ang_1, hingePointer.pan);
	ent_bonerotate(you, updatePart, temp_ang_1);
	ent_bonemove(you, updatePart, temp_mov);	 
}
//
//
//////////////////////////////////////////////////////////////////////////////////
//
// set rotation limits
void RD_setLimit(VECTOR* vec1, VECTOR* vec2) 
{
	vec_set(RD_Hinge1, vec1);
	vec_set(RD_Hinge2, vec2);
}
//
//
//////////////////////////////////////////////////////////////////////////////////
//
// initialise physics and hinges
void RD_BodyPartInit(var mass, ENTITY* entityMe) 
{
	set(entityMe, PASSABLE);
//	entityMe.pan = 180;
	phent_settype(entityMe, PH_RIGID, PH_BOX);
	phent_setmass(entityMe, mass, PH_BOX);
	//
	phent_setgroup(entityMe, RD_GroupID);
	phent_setfriction(entityMe, 15);
	phent_setdamping(entityMe, 35, 35);
	phent_setelasticity(entityMe, 35, 30); // bounciness
	//
	reset(entityMe, PASSABLE);
}
//
//
//////////////////////////////////////////////////////////////////////////////////
//
void RD_setHinge(ENTITY* constr_1, ENTITY* constr_2) {
	var tempHinge;
	
	// make constraint
	tempHinge = phcon_add(PH_HINGE, constr_1, constr_2); // attach to bodypart
	phcon_setparams1(tempHinge, constr_1.x, RD_Hinge1, nullvector); // set hinge limits
	phcon_setparams2(tempHinge, RD_Hinge2, nullvector, nullvector);    // same
}
//
//
//////////////////////////////////////////////////////////////////////////////////
//
void RD_blendPose(ENTITY* limb, ENTITY* actor, STRING* boneBlend) {
	phent_enable(limb, 0);
	vec_for_bone(limb.x, actor, boneBlend); // place at right position
	ang_for_bone(limb.pan, actor, boneBlend); // rotate by right angle
	phent_enable(limb, 1);
}
//
//
//////////////////////////////////////////////////////////////////////////////////
//
void RD_setPart() 
{
	set(my, FLAG2 | INVISIBLE);
}
//
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
#endif	//Ragdoll_h