// code for enemies that attack player
// new definition of previously created struct
AI* initmyAi() {
	// initialise memory for new item
	AI* myAi = sys_nxalloc( sizeof(AI) );
	
	// setup all variables
	myAi.myChar.Character = my;
	myAi.myChar.movementMode = moving;
	myAi.myChar.animationMode = moving;
	myAi.myChar.health = my.skill1; // set health based on skill1
	myAi.myChar.gravityOffset = 35;
	
	myAi.AiTarget = getAIEntity();
	vec_set(myAi.aiRot, nullvector);
	
	myAi.damageModifier = 2;
	
	// animation variables
	myAi.myChar.anim.currentblend = 0;
	myAi.myChar.anim.animate = 0;
	myAi.myChar.anim.animate2 = 0;
	myAi.myChar.anim.animblend = 0;
	myAi.myChar.anim.previousframe = 0;
	myAi.myChar.anim.currentframe = 0;
	myAi.myChar.anim.blendframe = 0;
	
	RunmyAi(myAi); // create ai's brain
	initAnimation(myAi.myChar.anim, myAi.myChar.Character, 7); // can be initiated for everyone
	
	// return pointer
	return(myAi);
}

// unique function that runs on every struct (main loop for each item)
void RunmyAi(AI* tempChar) {
	VECTOR tempAiRot;
	VECTOR prevPos;
	int nextAttackCheck = 0;
	int nextDamageCheck = 0;
	int randomAttackPick = 0;
	int prevComboRead = 0;
	
	int distToPlayer = 40;
	
	// make code understand that this object is the enemy by setting it's flag7 on, and make flag2 on for no collision on each other
	set(tempChar.myChar.Character, FLAG7 | FLAG2 | SHADOW | NARROW);
	
	//setup gliding and collision values	
//	c_setminmax(tempChar.myChar.Character);
	
	//setup push value to ignore lower objects
//	tempChar.myChar.Character.push = -2;
//	tempChar.myChar.Character.group = -2;
	
	// turn on gravity that pulls entity to the ground
	handleGrav(tempChar.myChar.Character, 8, tempChar.myChar.gravityOffset);
	
	// make sure some health is setup, be it weak
	if(tempChar.myChar.Character.skill2 == 0) { tempChar.myChar.Character.skill2 = 15; tempChar.myChar.health = tempChar.myChar.Character.skill2; }
	
	// run this function as long as the entity still exists and is not dead...
	while (tempChar.myChar.health > 0) {
		// set proper health
		tempChar.myChar.health = tempChar.myChar.Character.skill2;
		
		// reset target if new player has spawned
		if(tempChar.AiTarget.skill2 < 1) { // when player is dead; get new target
			tempChar.AiTarget = getAIEntity();
		}
		
		if(tempChar.myChar.movementMode == fighting) {
			// ----------------------------------------
			// Do checks to see if need to do damage
			// ----------------------------------------
			
			if((tempChar.myChar.anim.animate < 50) && ((tempChar.myChar.anim.animblend != blend) && (tempChar.myChar.anim.currentblend != move) && (tempChar.myChar.anim.currentblend != move))) {
				nextDamageCheck = 1; // set next attack availability
			}
			if((nextDamageCheck == 1) && (tempChar.myChar.anim.animate > 50)) {
				// reset attack check
				nextDamageCheck = 0;
				
				// trace forward from player position, based on rotation
				VECTOR traceTo;
				traceTo.x = tempChar.myChar.Character.x + cos(tempChar.myChar.Character.pan)*cos(tempChar.myChar.Character.tilt)*distToPlayer;
				traceTo.y = tempChar.myChar.Character.y + sin(tempChar.myChar.Character.pan)*cos(tempChar.myChar.Character.tilt)*distToPlayer;
				traceTo.z = tempChar.myChar.Character.z + sin(tempChar.myChar.Character.tilt)*distToPlayer;
				
				var traceResult = c_trace(tempChar.myChar.Character.x, traceTo, IGNORE_ME | IGNORE_PASSABLE | USE_POLYGON); // do the trace
				
				// if anything was hit and that anything is the enemy;
				if(traceResult != 0) {
					// if you're the player, and you're not blocking
					if(is(you, FLAG8) && !is(you, FLAG1)) {
						// check which attack it's currently doing
						if(tempChar.myChar.anim.currentframe == punch) {
							you.skill2 -= 5 * tempChar.damageModifier;
							// create punching effect on the enemy
							createNewSnd("Punch", 10);
							createNewSnd("Hit", 10);
							ent_create("damage_player.tga", you.x, impactHit);
						}
						if(tempChar.myChar.anim.currentframe == doublepunch) {
							you.skill2 -= 10 * tempChar.damageModifier;
							// create punching effect on the enemy
							createNewSnd("Punch", 10);
							createNewSnd("Hit", 10);
							ent_create("damage_player.tga", you.x, impactHit);
						}
						if(tempChar.myChar.anim.currentframe == kick) {
							you.skill2 -= 5 * tempChar.damageModifier;
							// create punching effect on the enemy
							createNewSnd("Kick", 9);
							createNewSnd("Hit", 10);
							ent_create("damage_player.tga", you.x, impactHit);
						}
						if(tempChar.myChar.anim.currentframe == doublekick) {
							you.skill2 -= 10 * tempChar.damageModifier;
							// create punching effect on the enemy
							createNewSnd("Kick", 9);
							createNewSnd("Hit", 10);
							ent_create("damage_player.tga", you.x, impactHit);
						}
					}
				}
			}
			
			// ----------------------------------------
			// Do checks to for animating
			// ----------------------------------------
			
			// check if next attack is available for checking
			if((tempChar.myChar.anim.animate > 90) || (tempChar.myChar.anim.currentblend == move)) {
				nextAttackCheck = 1; // set next attack availability
			}
			// update only if animation is finished or when first combo is started
			if((nextAttackCheck == 1) && ((tempChar.myChar.anim.animate < 90) && (tempChar.myChar.anim.animblend != blend))) {
				// reset attack check
				nextAttackCheck = 0;
				
				// branch off in 3 possible attacks...
				randomAttackPick = integer(random(4))+1; // return number between 1 - 4
				
				// punch
				if(randomAttackPick == 1) {
					// always do a punch
					if((tempChar.myChar.anim.currentblend != punch)){
						prevComboRead = punch;
						tempChar.myChar.anim.blendframe = punch; 
						tempChar.myChar.anim.currentblend = punch;
					}
					
					// when previousframe was punch already, do double punch!
					if((tempChar.myChar.anim.currentblend != doublepunch) && (tempChar.myChar.anim.previousframe == punch)){
						prevComboRead = doublepunch;
						tempChar.myChar.anim.blendframe = doublepunch; 
						tempChar.myChar.anim.currentblend = doublepunch; 
					}
					
					// update previousframe here
					tempChar.myChar.anim.previousframe = prevComboRead;
				} else if(randomAttackPick == 2) { // kick
					// always do a kick
					if((tempChar.myChar.anim.currentblend != kick)){
						prevComboRead = kick;
						tempChar.myChar.anim.blendframe = kick; 
						tempChar.myChar.anim.currentblend = kick;
					}
					
					// when previousframe was punch already, do double punch!
					if((tempChar.myChar.anim.currentblend != doublekick) && (tempChar.myChar.anim.previousframe == kick)){
						prevComboRead = doublekick;
						tempChar.myChar.anim.blendframe = doublekick; 
						tempChar.myChar.anim.currentblend = doublekick; 
					}
					
					// update previousframe here
					tempChar.myChar.anim.previousframe = prevComboRead;
				} else if(randomAttackPick >= 3) {
					// pause to catch breath :P
					if(tempChar.myChar.anim.currentblend != stand){ 
						prevComboRead = stand;
						tempChar.myChar.anim.blendframe = stand; 
						tempChar.myChar.anim.currentblend = stand; 
					}
				}
			}
			
			// ----------------------------------------
			// Do check if player is too far away, and need to relocate
			// ----------------------------------------
			
			if(vec_dist(tempChar.AiTarget.x, tempChar.myChar.Character.x) > distToPlayer) {
				tempChar.myChar.movementMode = moving;
			}
		} else if(tempChar.myChar.movementMode == moving) {
			if(vec_dist(tempChar.AiTarget.x, tempChar.myChar.Character.x) > distToPlayer) {
				vec_set(tempAiRot, tempChar.myChar.Character.pan); // store current rotation
				
				// get rotation to current threat
				vec_set(tempChar.aiRot, tempChar.AiTarget.x); 
				vec_sub(tempChar.aiRot, tempChar.myChar.Character.x);
				vec_to_angle(tempChar.aiRot, tempChar.aiRot); // now MY looks at YOU
				
				// update rotations..
				ang_lerp(tempChar.myChar.Character.pan, tempChar.myChar.Character.pan, tempChar.aiRot, 0.65 * time_step); // smoothly update rotation
				tempChar.myChar.Character.tilt = tempAiRot.y; tempChar.myChar.Character.roll = tempAiRot.z; // kill tilt and roll rotation
				
				// store previous position
				vec_set(prevPos, tempChar.myChar.Character.x);
				//make the player move around
				c_move(tempChar.myChar.Character, vector(6*time_step, 0, 0), nullvector, IGNORE_PASSABLE | IGNORE_PUSH | ACTIVATE_PUSH); // Move when key is pressed
				if(vec_dist(prevPos.x, tempChar.myChar.Character.x) < 1) { // if he didnt move from previous position
					if(tempChar.myChar.anim.currentblend != stand){ tempChar.myChar.anim.blendframe = stand; tempChar.myChar.anim.currentblend = stand; }
				} else {
					if(tempChar.myChar.anim.currentblend != move){ tempChar.myChar.anim.blendframe = move; tempChar.myChar.anim.currentblend = move; }
				}
			} else {
				// set AI mode
				tempChar.myChar.movementMode = fighting;
			}
		}
		
		wait(1);
	}
	
	createNewSnd("Death", 5);
	
	// turn this model into a ragdoll!
	RagDoll_Spawn(tempChar.myChar.Character);
	
	// remove (free) when object is useless (get's done upon level change automatically!)
//	ent_remove(tempChar.myChar.Character);
//	free(tempChar);
}