MOVECAM* initCamera() {
	// initialise memory for new item
	MOVECAM* myCamera = sys_nxalloc( sizeof(MOVECAM) );
	
	myCamera.focusPos = getPlayersFocus();
	myCamera.tempCam = ent_create("camera.mdl", myCamera.focusPos, NULL);
	
	vec_set(myCamera.position, nullvector);
	myCamera.updateSpeed = 8;
	myCamera.playerCamDist = 175;
	
	myCamera.CameraMode = moving;
	myCamera.arcZoom = 80;
	myCamera.arcZoomMax = 80;
	myCamera.arcZoomMin = 55;
	myCamera.arcZoomSpeed = 20;
	
	updateCamera(myCamera);
	
	// return pointer
	return(myCamera);
}

// function that handles camera position and updates
void updateCamera(MOVECAM* myCam) {
	// initial positioning of locked X-axis, can be changed later on if needed (for going onto more back placed platforms etc)
	var cameraLockedXPos;
	
	set(myCam.tempCam, INVISIBLE | PASSABLE);
	// setup first frame normal camera zoom
	camera.arc = myCam.arcZoom;
	myCam.tempCam.tilt = -35;
	
	vec_set(myCam.focusPos, getPlayersFocus());
	
//	vec_set(myCam.tempCam.x, vector(cameraLockedXPos, myCam.focusPos.y, myCam.focusPos.z + myCam.playerCamDist));
//	vec_set(camera.x, myCam.tempCam.x);
	vec_set(camera.x, vector(myCam.tempCam.x - myCam.playerCamDist, myCam.tempCam.y, myCam.tempCam.z + myCam.playerCamDist));
	vec_set(camera.pan, myCam.tempCam.pan);
	
	cameraLockedXPos = myCam.focusPos.x - myCam.playerCamDist; 
	
	while(myCam.tempCam) {
		// debugging stuff
		if(key_enter) {
			cameraLockedXPos = myCam.focusPos.x - myCam.playerCamDist; 
			while(key_enter) { wait(1); }
		}
		// end of debugging things
		
		// update player amount
		vec_set(myCam.focusPos, getPlayersFocus());
		while(myCam.focusPos == nullvector) { wait(1); } // wait if no player was initialised yet
		
		// calculate new camera positioning
		if(myCam.CameraMode == moving) {
			// make move along with player (zoom to normal view)
			camera.arc += ((myCam.arcZoomMax - camera.arc) / myCam.arcZoomSpeed) * time_step;
			
			// calculate new camera position
			vec_set(myCam.tempCam.x, vector(cameraLockedXPos, myCam.focusPos.y, myCam.focusPos.z + myCam.playerCamDist));
			// smoothly update camera towards that position
			camera.x += ((cameraLockedXPos - camera.x) / myCam.updateSpeed) * time_step;
			camera.y += ((myCam.tempCam.y - camera.y) / myCam.updateSpeed) * time_step;
			camera.z += ((myCam.tempCam.z - camera.z) / myCam.updateSpeed) * time_step;
		} else if(myCam.CameraMode == fighting) {
			// make focus on battle arena (zoom in etc)
			camera.arc += ((myCam.arcZoomMin - camera.arc) / myCam.arcZoomSpeed) * time_step;
			// still keep updating to last known position
			camera.x += ((cameraLockedXPos - camera.x) / myCam.updateSpeed) * time_step;
			camera.y += ((myCam.tempCam.y - camera.y) / myCam.updateSpeed) * time_step;
			camera.z += ((myCam.tempCam.z - camera.z) / myCam.updateSpeed) * time_step;
		}// room for more possible states (cutscenes etc etc etc)
		
		wait(1);
	}
	
	// remove any trace to this object when done with it (also done automatically upon level change)
//	ent_remove(myCam.tempCam);
//	free(myCam);
}
