// menu maps, buttons etc etc
BMAP* oldMenuLogo = "BG_old_DD2.tga";
BMAP* MainA7Logo = "a7_1024_logo.tga";
BMAP* MainMenuLogo = "BG_new_DD2.tga";
BMAP* MainMenuplay = "menu_play.tga";
BMAP* MainMenuexit = "menu_exit.tga";
BMAP* MainMenuplay_over = "menu_play_over.tga";
BMAP* MainMenuexit_over = "menu_exit_over.tga";
BMAP* MainMenu1p = "Menu_play_1p.tga";
BMAP* MainMenu1p_over = "Menu_play_1p_over.tga";
BMAP* MainMenu2p = "Menu_play_2p.tga";
BMAP* MainMenu2p_over = "Menu_play_2p_over.tga";

function mouse_toggle() // switches the mouse on and off
{ 
	mouse_map = NULL; // use arrow as mouse pointer
	
	if (mouse_mode >= 4) { // was it already on?
		mouse_mode = 0;
	} else {
		mouse_mode = 4; 
	} 
	while (mouse_mode > 0) // move it over the screen
	{  
		vec_set(mouse_pos,mouse_cursor);
		wait(1);
	}
}

PANEL* mainMenu = {
	button(0, 0, MainMenuplay, MainMenuplay, MainMenuplay_over, startMenu, NULL, NULL);
	button(0, 128, MainMenuexit, MainMenuexit, MainMenuexit_over, exitMenu, NULL, NULL);
}

PANEL* playMenu = {
	button(0, 0, MainMenu1p, MainMenu1p, MainMenu1p_over, start_1p, NULL, NULL);
	button(256, 0, MainMenu2p, MainMenu2p, MainMenu2p_over, start_2p, NULL, NULL);
}

void start_1p() {
	MultiplayerAmount = 1;
	startGame = 1;
}
void start_2p() {
	MultiplayerAmount = 2;
	startGame = 1;
}

void startMenu() {
	reset(mainMenu, SHOW);
	
	playMenu.pos_x = (screen_size.x/2)-playMenu.size_x / 2;
	playMenu.pos_y = (screen_size.y/2)-playMenu.size_y / 2;
	set(playMenu, SHOW);
}

void exitMenu() {
	sys_exit(NULL);
}

void createMainMenu() {
	// turn mouse on
	mouse_toggle();
	
	startGame = 0;
	
	// create menu on a lower layer
	PANEL* menuLogo;
	menuLogo = pan_create("bmap = MainMenuLogo; alpha = 100; flags = SHOW;", 4);
	
	menuLogo.pos_x = (screen_size.x/2)-menuLogo.size_x / 2;
	menuLogo.pos_y = (screen_size.y/4)-menuLogo.size_y / 2;
	
	mainMenu.pos_x = (screen_size.x/2)-mainMenu.size_x / 2;
	mainMenu.pos_y = (screen_size.y/2)+(screen_size.y/4)-mainMenu.size_y / 2;
	set(mainMenu, SHOW);
	
	// check for konami code input
	int konamiInputStorage[10];
	int addkonamiCode = 0;
	int inputKonamiCode = 0;
	
	var i;
	for(i=0; i<10; i++) {
		konamiInputStorage[i] = 0;
	}
	
	while(startGame == 0) {
		// make a very ugly check for the last input and reset if nescesary...
		if(key_any){
			if(inputKonamiCode == 0 && (key_pressed(key_for_str("cuu")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 1 && (key_pressed(key_for_str("cuu")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 2 && (key_pressed(key_for_str("cud")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 3 && (key_pressed(key_for_str("cud")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 4 && (key_pressed(key_for_str("cul")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 5 && (key_pressed(key_for_str("cur")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 6 && (key_pressed(key_for_str("cul")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 7 && (key_pressed(key_for_str("cur")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 8 && (key_pressed(key_for_str("a")))) { addkonamiCode = 1; while(key_any) { wait(1); } }
			if(inputKonamiCode == 9 && (key_pressed(key_for_str("b")))) { KonamiCodeSet = 1; }
			
			if(addkonamiCode == 1) {
				addkonamiCode = 0;
				inputKonamiCode += 1;
			}
		}
		
		if(KonamiCodeSet == 1) {
			draw_text("konami code set; Pixel mode unlocked", 700, 750, vector(255,255,255));
		}
		
		wait(1);
	}
	
	// turn panels off/remove
	pan_remove(menuLogo);
	reset(mainMenu, SHOW);
	reset(playMenu, SHOW);
	
	// turn mouse off
	mouse_toggle();
	// load the level
	levelChange("level_01.wmb");
}

void createMenu() {
	media_loop("sounds/DD2_Menu.mp3", NULL, 100);
	
	// create A7 logo
	PANEL* A7Logo;
	A7Logo = pan_create("bmap = MainA7Logo; alpha = 100; flags = SHOW | TRANSLUCENT;", 5);
	
	A7Logo.pos_x = (screen_size.x/2)-A7Logo.size_x / 2;
	A7Logo.pos_y = (screen_size.y/2)-A7Logo.size_y / 2;
	
	wait(-4);
	while(A7Logo.alpha > 0) { A7Logo.alpha -= 10 * time_step; wait(1); } // fade out
	
	// create old school double dragon logo
	PANEL* oldLogo;
	oldLogo = pan_create("bmap = oldMenuLogo; alpha = 0; flags = SHOW | TRANSLUCENT;", 5);
	
//	tempLogo.center_x = tempLogo.size_x / 2; // set the rotation center at the panel center
//	tempLogo.center_y = tempLogo.size_y / 2;
	
	oldLogo.pos_x = (screen_size.x/2)-oldLogo.size_x / 2;
	oldLogo.pos_y = (screen_size.y/2)-oldLogo.size_y / 2;
	
	while(oldLogo.alpha < 100) { oldLogo.alpha += 10 * time_step; wait(1); } // fade in
	pan_remove(A7Logo);
	
	createMainMenu();
	
	wait(-2);
	while(oldLogo.alpha > 0) { oldLogo.alpha -= 10 * time_step; wait(1); } // fade out
	pan_remove(oldLogo);
}