void RagDoll_Spawn(ENTITY* creator) 
{
	// can be combined in one allocation, but this way it's more readable
	ENTITY *Pelvis, *Stomach, *Torso, *Head;
	ENTITY *R_arm_up, *R_arm_down, *L_arm_up, *L_arm_down;
	ENTITY *R_leg_up, *R_leg_down, *L_leg_up, *L_leg_down;
	RD_GroupID += 1; // make all ragdolls collide on each other
	
	var tempVertex; // stores where next hinge is created
	
	// create ragdoll actor
	you = creator;
	set(you, PASSABLE);
	
	// go on creating the ragdoll PE objects
	Pelvis = ent_create("RD_pelvis.mdl", you.x, RD_setPart);
	RD_BodyPartInit(20, Pelvis); // create physics object and set weight
		// make constraint
		RD_setHinge(Pelvis, Pelvis);
		my = Pelvis;
	
	// left upper leg
	vec_for_vertex(tempVertex, Pelvis, 14); // get vertex to attach limb to
 	L_leg_up = ent_create("RD_leg_up_left.mdl", tempVertex, RD_setPart); // create bodypart
 	RD_setLimit(vector(0,1,0), vector(-60,90,0)); // set rotational boundaries
	RD_BodyPartInit(5, L_leg_up); // same as before, and from here keeps copying, but for different limbs every time
		// make constraint
		RD_setHinge(L_leg_up, Pelvis);
	
 	// left lower leg
 	vec_for_vertex(tempVertex, L_leg_up, 9);
	L_leg_down = ent_create("RD_leg_down_left.mdl", tempVertex, RD_setPart);
	RD_setLimit(vector(0,1,0), vector(0,150,0));
	RD_BodyPartInit(20, L_leg_down);
		// make constraint
		RD_setHinge(L_leg_down, L_leg_up);
 
	// right upper leg
	vec_for_vertex(tempVertex, Pelvis, 13);
 	R_leg_up =	ent_create("RD_leg_up_right.mdl", tempVertex, RD_setPart);
 	RD_setLimit(vector(0,1,0), vector(-60,90,0));
	RD_BodyPartInit(5, R_leg_up);
		// make constraint
		RD_setHinge(R_leg_up, Pelvis);
	
	// right lower leg
	vec_for_vertex(tempVertex, R_leg_up, 9);
 	R_leg_down =	ent_create("RD_leg_down_right.mdl", tempVertex, RD_setPart);
 	RD_setLimit(vector(0,1,0), vector(0,150,0));
	RD_BodyPartInit(20, R_leg_down);
		// make constraint
		RD_setHinge(R_leg_down, R_leg_up);
	
	// stomach
	vec_for_vertex(tempVertex, Pelvis, 15);
	Stomach = ent_create("RD_abs.mdl", tempVertex, RD_setPart);
	RD_setLimit(vector(1,1,0), vector(-25,25,0));
	RD_BodyPartInit(20, Stomach);
		// make constraint
		RD_setHinge(Stomach, Pelvis);
	
	//torso
	vec_for_vertex(tempVertex, Stomach, 9);
	Torso = ent_create("RD_torso.mdl", tempVertex, RD_setPart);
	RD_setLimit(vector(1,1,0), vector(-40,40,0));
	RD_BodyPartInit(55, Torso);
		// make constraint
		RD_setHinge(Torso, Stomach);
	
	// left upper arm
	vec_for_vertex(tempVertex, Torso, 10);
 	L_arm_up = ent_create("RD_arm_up_left.mdl", tempVertex, RD_setPart);
 	RD_setLimit(vector(1,1,1), vector(-90,90, 0));
	RD_BodyPartInit(5, L_arm_up);
		// make constraint
		RD_setHinge(L_arm_up, Torso);
	
	// left lower arm
	vec_for_vertex(tempVertex, L_arm_up, 9);
 	L_arm_down = ent_create("RD_arm_down_left.mdl", tempVertex, RD_setPart);
 	RD_setLimit(vector(1,0,0), vector(0,-140,0));
	RD_BodyPartInit(20, L_arm_down);
		// make constraint
		RD_setHinge(L_arm_down, L_arm_up);

	// right upper arm
	vec_for_vertex(tempVertex, Torso, 13);
 	R_arm_up = ent_create("RD_arm_up_right.mdl", tempVertex, RD_setPart);
 	RD_setLimit(vector(1,1,1), vector(-90,90, 0));
	RD_BodyPartInit(5, R_arm_up);
		// make constraint
		RD_setHinge(R_arm_up, Torso);
	
	// right lower arm
	vec_for_vertex(tempVertex, R_arm_up, 9);
 	R_arm_down = ent_create("RD_arm_down_right.mdl", tempVertex, RD_setPart);
 	RD_setLimit(vector(1,0,0), vector(0,-140,0));
	RD_BodyPartInit(20, R_arm_down);
		// make constraint
		RD_setHinge(R_arm_down, R_arm_up);
	
	// head
	vec_for_vertex(tempVertex, Torso, 9);
	Head = ent_create("RD_head.mdl", tempVertex, RD_setPart);
	RD_setLimit(vector(1,1,0), vector(-45,45,0));
	RD_BodyPartInit(25, Head);
		// make constraint
		RD_setHinge(Head, Torso);
	
	// blend all frames
	RD_blendPose(Pelvis, you, "pelvis");
	RD_blendPose(L_leg_up, you, "left_up_leg");
	RD_blendPose(L_leg_down, you, "left_low_leg");
	RD_blendPose(R_leg_up, you, "right_up_leg");
	RD_blendPose(R_leg_down, you, "right_low_leg");
	RD_blendPose(Stomach, you, "stomach");
	RD_blendPose(Torso, you, "chest");
	RD_blendPose(L_arm_up, you, "left_up_arm");
	RD_blendPose(L_arm_down, you, "left_low_arm");
	RD_blendPose(R_arm_up, you, "right_up_arm");
	RD_blendPose(R_arm_down, you, "right_low_arm");
	RD_blendPose(Head, you, "neck");
	
	while(you) {
		// set pelvis to right position
		vec_set(you.x, my.x);
		vec_set(you.pan, my.pan);
		
		// update all physics (limb) parts
		RD_updateBoneHinge(L_leg_up, "left_up_leg", you);
		RD_updateBoneHinge(L_leg_down, "left_low_leg", you);
		RD_updateBoneHinge(R_leg_up, "right_up_leg", you);
		RD_updateBoneHinge(R_leg_down, "right_low_leg", you);
		RD_updateBoneHinge(Stomach, "stomach", you);
		RD_updateBoneHinge(Torso, "chest", you);
		RD_updateBoneHinge(L_arm_up, "left_up_arm", you);
		RD_updateBoneHinge(L_arm_down, "left_low_arm", you);
		RD_updateBoneHinge(R_arm_up, "right_up_arm", you);	
		RD_updateBoneHinge(R_arm_down, "right_low_arm", you);
		RD_updateBoneHinge(Head, "neck", you);
		
		wait(1);
	}
}